
--***********************
--***** Stored data *****
--***********************

--The list of players and their scores in parallel arrays
FishingDerby_nameList = {"PLAYER"}
FishingDerby_scoreList = {"SCORE"}

--The time that an update was seen to the "That's A Lot of Bait" achievement
FishingDerby_savedTime = 0

--The player's name
FishingDerby_playerName = ""

--The host's name
FishingDerby_hostName = ""

--Boolean values recording the state of the contest
FishingDerby_hosting = false
FishingDerby_playing = false
FishingDerby_contestRunning = false

--This constant controls the maximum amount of time that can elapse between the
--TRACKED_ACHIEVEMENT_UPDATE event (a pool catch in the guild has been recognized)
--and the time that the player's fish is looted.
--If short, it probably means that it was the player that caught it
--If longer, the catch was probably from open water and doesn't count

MAX_DELAY = 0.85

--dgfish variables
dgfishdoublekilltimer = 14 
dgfishdoublekill = 0
dgfishlastcatch = 0
dgfishsound1 = 5
dgfishsound1file = "Interface\\AddOns\\dgfish\\sounds\\ownage.ogg" 
dgfishsound2 = 10
dgfishsound2file = "Interface\\AddOns\\dgfish\\sounds\\killingspree.ogg"
dgfishsound3 = 15 
dgfishsound3file = "Interface\\AddOns\\dgfish\\sounds\\rampage.ogg" 
dgfishsound4 = 20
dgfishsound4file = "Interface\\AddOns\\dgfish\\sounds\\dominating.ogg"
dgfishsound5 = 25
dgfishsound5file = "Interface\\AddOns\\dgfish\\sounds\\unstoppable.ogg"
dgfishsound6 = 30
dgfishsound6file = "Interface\\AddOns\\dgfish\\sounds\\godlike.ogg"
dgfishsound7 = 35
dgfishsound7file = "Interface\\AddOns\\dgfish\\sounds\\whickedsick.ogg" 
dgfishstartsoundfile = "Interface\\AddOns\\dgfish\\sounds\\prepare.ogg"
dgfishdoublekillsoundfile = "Interface\\AddOns\\dgfish\\sounds\\doublekill.ogg"
dgfishtriplekillsoundfile = "Interface\\AddOns\\dgfish\\sounds\\multikill.ogg"
dgfishquadkillsoundfile = "Interface\\AddOns\\dgfish\\sounds\\megakill.ogg"
dgfish5killsoundfile = "Interface\\AddOns\\dgfish\\sounds\\ultrakill.ogg"
dgfish6killsoundfile = "Interface\\AddOns\\dgfish\\sounds\\monsterkill.ogg"
dgfish7killsoundfile = "Interface\\AddOns\\dgfish\\sounds\\ludicrouskill.ogg"
dgfish8killsoundfile = "Interface\\AddOns\\dgfish\\sounds\\holyshit.ogg"


--**************************************
--Basic functions for moving the windows

function FishingDerby_OnMouseDown()
	FishingDerby_Frame:StartMoving()
end

function FishingDerby_OnMouseUp()
	FishingDerby_Frame:StopMovingOrSizing()
end	

function FishingDerby_MinimizedFrame_OnMouseDown()
	FishingDerby_MinimizedFrame:StartMoving()
end

function FishingDerby_MinimizedFrame_OnMouseUp()
	FishingDerby_MinimizedFrame:StopMovingOrSizing()
end	

--********************************
--FishingDerby functions
--Called directly from XML code

function FishingDerby_OnLoad()
	print("Loaded dG Fishin' Derby")
	print("Tracking \"That's a Lot of Bait\" achievement")
	AddTrackedAchievement(5036)
	FishingDerby_playerName = GetUnitName("player",false)
	FishingDerby_MinimizedFrame:Hide()
	FishingDerby_redisplayNamesAndScores()
	
	--Only Minimize and Init should be enabled at the start
	FishingDerby_Frame_Host:Disable()
	FishingDerby_Frame_Init:Enable()
	FishingDerby_Frame_Join:Disable()
	FishingDerby_Frame_ZeroAll:Disable()
	FishingDerby_Frame_Start:Disable()
	FishingDerby_Frame_ClearList:Disable()
	
	--NEW FOR 4.1--
	local AllIsWell = true
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_CHECK")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_HOSTLOST")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_HOSTFOUND")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_PLAYERJOINS")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_START")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_STOP")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_ZEROALL")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_CLEARLIST")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_CATCH")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_UPDATE_SCORE")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_ADDPLAYER")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_STATE")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_GETSCORES")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_SCORES")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_SOUND")
	AllIsWell = AllIsWell and RegisterAddonMessagePrefix("FD_TEXT")
	if(not AllIsWell) then
		print("FishingDerby: ERROR - Messages could not be registered")
		print("This MIGHT be caused by the presence of too many addons.")
		print("This addon may not function correctly.")
	end
	
end

---The following react to the 8 different buttons (7 in the main frame
---and one in the minimized frame)

function FishingDerby_InitPressed()
	--Enable host button in case no response is obtained (so no host)
	--If there is a host it will immediately be disabled again by the response
	FishingDerby_Frame_Host:Enable()
	--It should only be "Initialize" at first. After that it's "Refresh".
	FishingDerby_Frame_Init:SetText("Refresh")
	--Send a "Is any host out there?" message
	SendAddonMessage("FD_CHECK", FishingDerby_playerName, "GUILD", "")	
end

function FishingDerby_HostPressed()
	if(FishingDerby_hosting) then
		--It's an "Unhost" button in that case
		if(FishingDerby_contestRunning) then
			--It's actually a Stop button when you're
			--hosting a running contest. Stop the contest first.
			FishingDerby_StartPressed()
		end
		FishingDerby_hosting = false
		SendAddonMessage("FD_HOSTLOST", "", "GUILD", "")
		FishingDerby_Frame_Host:SetText("Host")
		FishingDerby_Frame_ZeroAll:Disable()
		FishingDerby_Frame_Start:Disable()
		FishingDerby_Frame_ClearList:Disable()
		--Hosts aren't allowed to use "Refresh". When no longer host, you are again.
		FishingDerby_Frame_Init:Enable()
	else
		--It's a host button. Set you up as host.
		FishingDerby_hosting = true
		SendAddonMessage("FD_HOSTFOUND", FishingDerby_playerName, "GUILD", "")
		FishingDerby_Frame_ZeroAll:Enable()
		FishingDerby_Frame_Start:Enable()
		FishingDerby_Frame_ClearList:Enable()
		FishingDerby_Frame_Host:SetText("Unhost")
		--The host cannot use "refresh" since it's the host that needs
		--to respond to it. The host can't ask the host - nonsensical.
		FishingDerby_Frame_Init:Disable()	
	end
end

function FishingDerby_JoinPressed()
	FishingDerby_playing = true
	SendAddonMessage("FD_PLAYERJOINS", FishingDerby_playerName, "WHISPER", FishingDerby_hostName)
	FishingDerby_Frame_Join:Disable()
end

function FishingDerby_MinimizePressed()
	FishingDerby_Frame:Hide();
	FishingDerby_MinimizedFrame:Show()
end

function FishingDerby_ShowPressed()
	FishingDerby_Frame:Show();
	FishingDerby_MinimizedFrame:Hide()
end

function FishingDerby_StartPressed()
	if not FishingDerby_contestRunning then
		--START a contest
		FishingDerby_Frame_Start:SetText("Stop")
		SendAddonMessage("FD_START", "", "GUILD", "")	
	else
		--STOP a contest
		FishingDerby_Frame_Start:SetText("Start")
		SendAddonMessage("FD_STOP", "", "GUILD", "")
	end
end

function FishingDerby_ZeroAllPressed()
	SendAddonMessage("FD_ZEROALL", "", "GUILD", "")
end

function FishingDerby_ClearListPressed()
	SendAddonMessage("FD_CLEARLIST", "", "GUILD", "")
end


--*******************************
--Event Handler
--  Checks for all the different events that are caught
--  Simple structure: Just one IF for each one


function FishingDerby_OnEvent(self,event,...)

	if(event == "TRACKED_ACHIEVEMENT_UPDATE") then
		--Save the time when an update to the achievement counter happened
		FishingDerby_savedTime = GetTime()
	end

	if(event == "LOOT_OPENED") then
		if(IsFishingLoot() and FishingDerby_playing and FishingDerby_contestRunning) then
			local elapsedTime = GetTime()-FishingDerby_savedTime
			if(elapsedTime < MAX_DELAY) then
				--print("Caught one!")
				--Send an FD_CATCH message to the host when a fish is caught
 				SendAddonMessage("FD_CATCH", FishingDerby_playerName, "WHISPER", FishingDerby_hostName)		
				if (dgfishlastcatch + dgfishdoublekilltimer > GetTime()) then
					--doublekill
					dgfishdoublekill = dgfishdoublekill + 1
					if (dgfishdoublekill == 1) then
						SendAddonMessage("FD_SOUND", dgfishdoublekillsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a doublekill." , "GUILD", "")
					elseif (dgfishdoublekill == 2) then
						SendAddonMessage("FD_SOUND", dgfishtriplekillsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a triplekill." , "GUILD", "")
					elseif (dgfishdoublekill == 3) then
						SendAddonMessage("FD_SOUND", dgfishquadkillsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a quadkill." , "GUILD", "")
					elseif (dgfishdoublekill == 4) then
						SendAddonMessage("FD_SOUND", dgfish5killsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a 5kill." , "GUILD", "")
					elseif (dgfishdoublekill == 5) then
						SendAddonMessage("FD_SOUND", dgfish6killsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a 6kill." , "GUILD", "")
					elseif (dgfishdoublekill == 6) then
						SendAddonMessage("FD_SOUND", dgfish7killsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a 7kill." , "GUILD", "")
					elseif (dgfishdoublekill > 6) then
						SendAddonMessage("FD_SOUND", dgfish8killsoundfile, "GUILD", "")
						SendAddonMessage("FD_TEXT", FishingDerby_playerName .. " got a 8kill." , "GUILD", "")
					end
				else 
					dgfishdoublekill = 0
			        end
				dgfishlastcatch = GetTime()
			end
		end
	end

	--All the rest are inter-Addon messages with different prefixes
	if(event == "CHAT_MSG_ADDON") then
		local prefix, message, type, sender = ...
		
		--For debugging only
		--print(prefix .. " received with message=" .. message)
		
		--FD_CATCH should only be received and processed by the host
		--Simply broadcast an FD_UPDATE_SCORE message to everyone
		--The "message" parameter will be the name of the person who caught it
		if(prefix == "FD_CATCH") then
			if(FishingDerby_hosting) then
				SendAddonMessage("FD_UPDATE_SCORE", message, "GUILD", "")
			end
		end
	        if(prefix == "FD_SOUND") then
			PlaySoundFile(message)
		end
		if(prefix == "FD_TEXT") then
			print(message)
		end
		--FD_UPDATE_SCORE means some player's score should be incremented and redisplayed
		--The "message" parameter will be the name of the person who should be updated
		if(prefix == "FD_UPDATE_SCORE") then
			--call a utility routine (at the bottom) which adjusts and redisplays
			FishingDerby_incrementScore(message)
		end

		--FD_HOSTFOUND means that a new host has been found
		if(prefix == "FD_HOSTFOUND") then
			FishingDerby_hostName = message
			FishingDerby_HostStatus:SetText("Host: " .. message)
			if( not (message == FishingDerby_playerName))then
				--It's not me who's hosting
				--If it is, leave this enabled since it's now the "Unhost" button
				FishingDerby_Frame_Host:Disable()
			end
			if(noSuchPlayer(FishingDerby_playerName)) then
				--You can now join, since there's a host
				--But not if you're already playing
				FishingDerby_Frame_Join:Enable()
			end
		end		

		--FD_HOSTLOST means that there is now no host
		if(prefix == "FD_HOSTLOST") then
			print(FishingDerby_hostName .. " is no longer a Fishing Derby host.")
			FishingDerby_hostName = ""
			FishingDerby_HostStatus:SetText("Host: no host")
			
			FishingDerby_Frame_Host:Enable()
			FishingDerby_Frame_Join:Disable()
			FishingDerby_playing = false
		end

		--FD_PLAYERJOINS is sent only to the host when a new player joins
		if(prefix == "FD_PLAYERJOINS") then
			if(FishingDerby_hosting) then
				SendAddonMessage("FD_ADDPLAYER", message, "GUILD", "")
			end
		end

		--FD_ADDPLAYER is sent to the clients to that they can all add the player
		if(prefix == "FD_ADDPLAYER") then
			print(message .. " has joined the derby.")
			if(noSuchPlayer(message)) then
				table.insert(FishingDerby_nameList,message)
				table.insert(FishingDerby_scoreList,0)
				FishingDerby_redisplayNamesAndScores()
			end
		end

		--FD_START starts up the contest
		if(prefix == "FD_START") then
			print("FISHING DERBY STARTED BY THE HOST")
			print("ON YOUR MARK....GET SET....FISH!")
			FishingDerby_contestRunning = true
			FishingDerby_ContestStatus:SetTextColor(0,1,0,1)
			FishingDerby_ContestStatus:SetText("Contest running")
			PlaySoundFile(dgfishstartsoundfile)
		end

		--FD_STOP stops the contest
		if(prefix == "FD_STOP") then
			print("FISHING DERBY STOPPED BY THE HOST")
			FishingDerby_contestRunning = false
			FishingDerby_ContestStatus:SetTextColor(1,0,0,1)
			FishingDerby_ContestStatus:SetText("Contest not running")
		end

		--FD_CHECK means someone is looking for the host. Only the host responds.
		if(prefix == "FD_CHECK") then
			--TEMPORARY FOR DEBUGGING
			--print("Got a CHECK message from " .. message)
			if(FishingDerby_hosting) then
				--"message" is the name of the enquiring player
				--Send a message of the form HostName/T
				--Where the boolean value indicates whether a contest is in progress
				local statusMessage = FishingDerby_hostName .. "/"
				if FishingDerby_contestRunning then
					statusMessage = statusMessage .. "T"
				else
					statusMessage = statusMessage .. "F"
				end
				--TEMPORARY FOR DEBUGGING
				--print("Sending a STATE message to " .. message)
				SendAddonMessage("FD_STATE",statusMessage, "WHISPER", message)
			end
		end

		--FD_STATE sets the current state of the contest for a new arrival
		--or for someone who has pressed "Refresh"
		--based on a response from the host
		if(prefix == "FD_STATE") then
			local name, running = string.match(message,"(%a+)/(%a)")
			--print(name .. " is hosting a FishingDerby Contest")
			FishingDerby_hostName = name
			FishingDerby_HostStatus:SetText("Host: " .. name)
			FishingDerby_contestRunning = (running == "T")
			if(FishingDerby_contestRunning) then
				FishingDerby_ContestStatus:SetTextColor(0,1,0,1)
				FishingDerby_ContestStatus:SetText("Contest running")
			else
				FishingDerby_ContestStatus:SetTextColor(1,0,0,1)
				FishingDerby_ContestStatus:SetText("Contest not running")
			end
			FishingDerby_Frame_Host:Disable()
			--Assume you won't be in the list of players. FD_SCORES will do the
			--opposite if your name is actually seen in the list.
			FishingDerby_Frame_Join:Enable()
			FishingDerby_playing = false
			
			--Empty the list of players and scores and request a new one.
			FishingDerby_nameList = {"PLAYER"}
			FishingDerby_scoreList = {"SCORE"}
			--Redisplay now since we might not even get a response if there are no players
			FishingDerby_redisplayNamesAndScores()
			SendAddonMessage("FD_GETSCORES",FishingDerby_playerName, "WHISPER", FishingDerby_hostName)
		end

		--FD_GETSCORES is only handled by the host. The response is to send
		--the names and scores of 10 players at a time to the requester (message)
		--using the FD_SCORES message
		if(prefix == "FD_GETSCORES") then
			--Start at number 2 since line 1 is the title line
			local next = 2
			local last = table.maxn(FishingDerby_nameList)
			while(next <= last) do
				--collect next 10 or fewer names
				local messageString = ""
				for i = 1,10 do
					messageString = messageString .. FishingDerby_nameList[next] .. "/" .. FishingDerby_scoreList[next] .. "/"
					next = next + 1
					if (next > last) then
						break
					end
				end
				SendAddonMessage("FD_SCORES",messageString, "WHISPER", message)
			end
		end
		
		--FD_SCORES adds up to 10 new players and their scores to the list
		--Redisplay every time (since we don't know how many of these we will get
		if(prefix == "FD_SCORES") then
			for nextname, nextscore in string.gmatch(message,"(%a+)/(%d+)/") do
				table.insert(FishingDerby_nameList,nextname)
				table.insert(FishingDerby_scoreList,nextscore)
				if(nextname == FishingDerby_playerName) then
					--I'm playing!!
					FishingDerby_Frame_Join:Disable()
					FishingDerby_playing = true		
				end
			end
			FishingDerby_redisplayNamesAndScores()
		end

		--FD_ZEROALL resets everyone's score to 0
		if(prefix == "FD_ZEROALL") then
			FishingDerby_scoreList = {"SCORE"}
			for i=2,table.maxn(FishingDerby_nameList) do
				table.insert(FishingDerby_scoreList,0)
			end
			FishingDerby_redisplayNamesAndScores()
		end

		--FD_CLEARLIST resets the list of players to an empty list
		if(prefix == "FD_CLEARLIST") then
			FishingDerby_nameList = {"PLAYER"}
			FishingDerby_scoreList = {"SCORE"}
			FishingDerby_playing = false
			FishingDerby_Frame_Join:Enable()
			FishingDerby_redisplayNamesAndScores()
		end

	end	
end


--********************************
--Utility functions called locally

function FishingDerby_incrementScore(name)
	for i=2,table.maxn(FishingDerby_nameList) do
		if(name==FishingDerby_nameList[i]) then
			FishingDerby_scoreList[i] = FishingDerby_scoreList[i] + 1
			FishingDerby_redisplayScores()
			if(FishingDerby_scoreList[i] == dgfishsound1) then
				PlaySoundFile(dgfishsound1file)
				print(name .. " is owning.")
			elseif(FishingDerby_scoreList[i] == dgfishsound2) then
				PlaySoundFile(dgfishsound2file)
				print(name .. " is on a killing spree.")
			elseif(FishingDerby_scoreList[i] == dgfishsound3) then
				PlaySoundFile(dgfishsound3file)
				print(name .. " is on a rampage.")
			elseif(FishingDerby_scoreList[i] == dgfishsound4) then
				PlaySoundFile(dgfishsound4file)
				print(name .. " is dominating.")
			elseif(FishingDerby_scoreList[i] == dgfishsound5) then
				PlaySoundFile(dgfishsound5file)
				print(name .. " is unstoppable.")
			elseif(FishingDerby_scoreList[i] == dgfishsound6) then
				PlaySoundFile(dgfishsound6file)
				print(name .. " is godlike.")
			elseif(FishingDerby_scoreList[i] > dgfishsound6 and FishDerby_scoreList[i] % 5 == 0) then
				PlaySoundFile(dgfishsound7file)
				print(name .. " is whicked sick!")
			end
			break
		end
	end
end

-----------------

function FishingDerby_redisplayScores()
	FishingDerby_ScoreDisplayFrame_Scores:SetText(table.concat(FishingDerby_scoreList,"\n"))
end

-----------------

function FishingDerby_redisplayNamesAndScores()
	FishingDerby_ScoreDisplayFrame_Players:SetText(table.concat(FishingDerby_nameList,"\n"))
	FishingDerby_ScoreDisplayFrame_Scores:SetText(table.concat(FishingDerby_scoreList,"\n"))
end

-----------------

function noSuchPlayer(playername)
	local found = false
	for i=1,table.maxn(FishingDerby_nameList) do
		if(playername==FishingDerby_nameList[i]) then
			found = true
			break
		end
	end
	return not found
end
